/******************************************************************/
/* ӲӣPB0-PB7---DB0-DB7   8λ                             */
/*           PC0-PC7---DB8-DB7   8λ                             */
/*           PD2---WR  PC12---RD PC11---CS  PC10---RS  PB11---CM   */            
/******************************************************************/
#include"stm32f0xx.h"
#include"ili9328.h"
#include "ascii.h"
#include "stdint.h"

uint16_t  POINT_COLOR=BLACK;
uint16_t  BACK_COLOR=WHITE;
/**************************************************/
/* ܣʱΪLCDʼʱ        */
/**************************************************/	

static void delay (int cnt) {

  cnt <<= DELAY_2N;
  while (cnt--);
}
/***************************************************/
/* ܣILI9325ļĴд               */
/* ڲval16λ                         */
/* ˵    д16λݣѧϰϵLCD8λӣ*/
/*           ԣ16λݷдĴд*/
/*           λдλ                        */
/* ע⣺ʹʱҪʹTFT_WR_REG(reg)ѡҪ */
/*       дĸĴ档                    */
/***************************************************/
void TFT_WR_DATA(uint16_t val)
{  
	
 	Set_Rs;
	Clr_Cs;
// 	Set_nRd;	
  GPIOB->ODR &= 0xff00;
  GPIOC->ODR &= 0xff00;		
	GPIOB->ODR|=((val)&(0x00ff));
	GPIOC->ODR|=(val>>8);
	Clr_nWr;
	Set_nWr;
  Set_Cs;	
}

/****************************************************/
/* ܣILI9238дӦĴ         */
/* ڲд                                 */
/* ˵    Ĵ16λ8λӷʽҪд*/
/****************************************************/
void TFT_WR_REG(uint16_t cmd)
{
	Clr_Rs;
	Clr_Cs;
// 	Set_nRd;
	 GPIOB->ODR &= 0xff00;
   GPIOC->ODR &= 0xff00;	
	GPIOB->ODR |=((cmd)&(0x00ff));
	GPIOC->ODR|=(cmd>>8);
	Clr_nWr;
	Set_nWr;
	 Set_Cs;	
	}
/******************************************************/
/* ܣwĴд                        */
/* ڲregĴ  dataֵ             */
/* ˵    úǰĺϳɣҲ */
/*           һ÷ϡ             */
/******************************************************/

void TFT_WR_REG_DATA(uint16_t reg, uint16_t data)
{ 
	 
   	TFT_WR_REG(reg);
   	TFT_WR_DATA(data);
 	
	}	
	
	
/****************************************************/
/* ܣILI9238ж                      */
/* ڲ                               */
/* ˵    Ĵ16λ8λӷʽҪд*/
/****************************************************/
uint16_t TFT_RD_DATA(void)
{ 
	unsigned short val,val1,val2;
	Set_Rs;
	Set_nWr;
	Clr_nRd;
	GPIOB->MODER&=0xffff0000;		   
  GPIOC->MODER&=0xffff0000;
	val1 = GPIOB->IDR;
	val2 = GPIOC->IDR;
	val=((val1)&(0x00ff))+((val2<<8)&(0xff00));
	               //˺Ϊ
		GPIOB->MODER|=0x00005555; 
		GPIOC->MODER|=0x00005555; 
	Set_nRd;
	return val;
}	

/******************************************************/
/* ܣwĴ                        */
/* ڲregĴ                           */
/* ˵    úǰĺϳɣҲ */
/*           һ÷ϡ             */
/******************************************************/
uint16_t  TFT_RD_REG_DATA (uint16_t  reg) 
{
  uint16_t value;
 	Clr_Cs;
	TFT_WR_REG(reg);    
	value = TFT_RD_DATA();      	
	Set_Cs;
	return value;
}

/*******************************************************/
/* ܣʼLCD                                 */
/*******************************************************/
void TFT_Init (void) 
{ uint16_t i;
	//////////////////////////////////////////////////////////////////////ܽųʼ
	 RCC->AHBENR&=0xffe3ffff;
	 RCC->AHBENR|=0x001c0000;
	
	GPIOB->MODER&=0xffff0000;		   // PBڵ8λΪLCD16λݺͿ
	GPIOB->MODER|=0x00005555;  
// 	GPIOB->BSRR=0x00ff;
  GPIOB->ODR &= 0xff00;	
// 	GPIOB->ODR |= 0x00ff;	   // PBڵ8λø
	
	GPIOC->MODER&=0xffff0000;		   // PCڵ8λΪLCD16λݺͿ
	GPIOC->MODER|=0x00005555; 
// 	GPIOC->BSRR=0x00ff;
	GPIOC->ODR &= 0xff00;	
// 	GPIOC->ODR |= 0x00ff;	   // PCڵ8λø
	
	GPIOB->MODER&=0xff3fffff;
	GPIOB->MODER|=0x00400000;  //PB11Ϊģʽ
	GPIOB->BRR =0x00000800;    //Ϊ͵ƽ
	
	 GPIOC->MODER&= 0xfc0fffff;                                   //PD2---WR  PC12---RD PC11---CS  PC10---RS  
   GPIOC->MODER|=0x01500000;
	 
	 GPIOC->BSRR = 0x00001c00;
	 GPIOD->MODER&= 0xffffffcf;
   GPIOD->MODER|=0x00000010;
	 
	 GPIOD->BSRR = 0x00000004;
//////////////////////////////////////////////////////////////////	
	
	delay(5);                             /* Delay 50 ms                        */

	TFT_WR_REG_DATA(0x00e7,0x0010);      
	TFT_WR_REG_DATA(0x0000,0x0001);  			//start internal osc
	TFT_WR_REG_DATA(0x0001,0x0100);     
	TFT_WR_REG_DATA(0x0002,0x0700); 				//power on sequence                     
	TFT_WR_REG_DATA(0x0003,(1<<12)|(1<<5)|(1<<4) ); 	//65K 
	TFT_WR_REG_DATA(0x0004,0x0000);                                   
	TFT_WR_REG_DATA(0x0008,0x0207);	           
	TFT_WR_REG_DATA(0x0009,0x0000);         
	TFT_WR_REG_DATA(0x000a,0x0000); 				//display setting         
	TFT_WR_REG_DATA(0x000c,0x0001);				//display setting          
	TFT_WR_REG_DATA(0x000d,0x0000); 				//0f3c          
	TFT_WR_REG_DATA(0x000f,0x0000);
	//Power On sequence //
	TFT_WR_REG_DATA(0x0010,0x0000);   
	TFT_WR_REG_DATA(0x0011,0x0007);
	TFT_WR_REG_DATA(0x0012,0x0000);                                                                 
	TFT_WR_REG_DATA(0x0013,0x0000);                 
	for(i=50000;i>0;i--);
	for(i=50000;i>0;i--);
  TFT_WR_REG_DATA(0x0010,0x1590);   
	TFT_WR_REG_DATA(0x0011,0x0227);
	for(i=50000;i>0;i--);
	for(i=50000;i>0;i--);
	TFT_WR_REG_DATA(0x0012,0x009c);                  
	for(i=50000;i>0;i--);
	for(i=50000;i>0;i--);
	TFT_WR_REG_DATA(0x0013,0x1900);   
	TFT_WR_REG_DATA(0x0029,0x0023);
	TFT_WR_REG_DATA(0x002b,0x000e);
	for(i=50000;i>0;i--);
	for(i=50000;i>0;i--);
	TFT_WR_REG_DATA(0x0020,0x0000);                                                            
	TFT_WR_REG_DATA(0x0021,0x0000);           
	///////////////////////////////////////////////////////      
	for(i=50000;i>0;i--);
	for(i=50000;i>0;i--);
	TFT_WR_REG_DATA(0x0030,0x0007); 
	TFT_WR_REG_DATA(0x0031,0x0707);   
	TFT_WR_REG_DATA(0x0032,0x0006);
	TFT_WR_REG_DATA(0x0035,0x0704);
	TFT_WR_REG_DATA(0x0036,0x1f04); 
	TFT_WR_REG_DATA(0x0037,0x0004);
	TFT_WR_REG_DATA(0x0038,0x0000);        
	TFT_WR_REG_DATA(0x0039,0x0706);     
	TFT_WR_REG_DATA(0x003c,0x0701);
	TFT_WR_REG_DATA(0x003d,0x000f);
	for(i=50000;i>0;i--);
	for(i=50000;i>0;i--);
	TFT_WR_REG_DATA(0x0050,0x0000);        
	TFT_WR_REG_DATA(0x0051,0x00ef);   
	TFT_WR_REG_DATA(0x0052,0x0000);     
	TFT_WR_REG_DATA(0x0053,0x013f);
	TFT_WR_REG_DATA(0x0060,0xa700);        
	TFT_WR_REG_DATA(0x0061,0x0001); 
	TFT_WR_REG_DATA(0x006a,0x0000);
	TFT_WR_REG_DATA(0x0080,0x0000);
	TFT_WR_REG_DATA(0x0081,0x0000);
	TFT_WR_REG_DATA(0x0082,0x0000);
	TFT_WR_REG_DATA(0x0083,0x0000);
	TFT_WR_REG_DATA(0x0084,0x0000);
	TFT_WR_REG_DATA(0x0085,0x0000);
	
	TFT_WR_REG_DATA(0x0090,0x0010);     
	TFT_WR_REG_DATA(0x0092,0x0000);  
	TFT_WR_REG_DATA(0x0093,0x0003);
	TFT_WR_REG_DATA(0x0095,0x0110);
	TFT_WR_REG_DATA(0x0097,0x0000);        
	TFT_WR_REG_DATA(0x0098,0x0000);  
	 //display on sequence     
	TFT_WR_REG_DATA(0x0007,0x0133);
	
	TFT_WR_REG_DATA(0x0020,0x0000);                                                            
	TFT_WR_REG_DATA(0x0021,0x0000);
 
}

/****************************************************************************
*     ƣvoid GTFT_Test(void)
*     ܣҺ
* ڲ
* ڲ
* ˵    ʾҺǷ
* ÷GTFT_Test();
****************************************************************************/
void GTFT_Test(void)
{
  uint16_t i,j;
  TFT_WR_REG_DATA(0x20, 0);
  TFT_WR_REG_DATA(0x21, 0);

  Clr_Cs; 
  TFT_WR_REG(0x22);
  
  for(i=0;i<320;i++)
    for(j=0;j<240;j++)
    {
      if(i>279)TFT_WR_DATA(0x0000);
      else if(i>239)TFT_WR_DATA(0x001f);
      else if(i>199)TFT_WR_DATA(0x07e0);
      else if(i>159)TFT_WR_DATA(0x07ff);
      else if(i>119)TFT_WR_DATA(0xf800);
      else if(i>79)TFT_WR_DATA(0xf81f);
      else if(i>39)TFT_WR_DATA(0xffe0);
      else TFT_WR_DATA(0xffff);
    }
  Set_Cs;
}

/**********************************************/
/* ܣʾ                         */
/* ˵    һڹرʾĿ         */
/**********************************************/
void TFT_DisplayOn(void)
{
 	TFT_WR_REG_DATA(0x0007, 0x0133); // ʾ
}
/**********************************************/
/* ܣرʾ                         */
/* ˵    ʹTFTʹTFTϵ */
/*           ݱֲ䣬һTFT*/
/*           ģӣģʱ */
/*           ϣӰTFTʾ          */
/**********************************************/
void TFT_DisplayOff(void)
{
	TFT_WR_REG_DATA(0x0007, 0x0); // رʾ
}

/***************************************************/
/* ܣԴ                          */
/* ˵    ýҪʾԴXYʼͽ    */
/* ע    ⣺ԺҪָ(0,0)յ(239,319)*/
/***************************************************/
void TFT_XYRAM(uint16_t xstart ,uint16_t ystart ,uint16_t xend ,uint16_t yend)
{
	TFT_WR_REG_DATA(0x0050, xstart); // úGRAMʼַ
	TFT_WR_REG_DATA(0x0051, xend); // úGRAMַ
	TFT_WR_REG_DATA(0x0052, ystart); // GRAMʼַ
	TFT_WR_REG_DATA(0x0053, yend); // GRAMַ
}

/*******************************************************/
/* ܣTFTʼ                         */
/*******************************************************/
void TFT_SetC(uint16_t x, uint16_t y)
{
	TFT_WR_REG_DATA(0x0020,x);  //Xλ
	TFT_WR_REG_DATA(0x0021,y);  //Yλ
}
/**********************************************/
/* ܣTFT                          */
/* ڲcolor ɫֵ                     */
/**********************************************/
void TFT_Clear(uint16_t color)
{
    uint32_t temp;
    TFT_WR_REG_DATA(0x0020,0);//Xλ
    TFT_WR_REG_DATA(0x0021,0);//Yλ
    TFT_WR_REG(0x0022);				//ָRAMĴ׼дݵRAM
	for(temp=0;temp<76800;temp++)
	{
		TFT_WR_DATA(color);    
	}
}
/******************************************/
/* ܣһصĵ               */
/* ڲx,y                  */
/******************************************/
void TFT_DrawPoint(uint16_t x,uint16_t y)
{
	TFT_WR_REG_DATA(0x0020,x);//Xλ
    TFT_WR_REG_DATA(0x0021,y);//Yλ
	TFT_WR_REG(0x0022);       //ʼдGRAM
	TFT_WR_DATA(POINT_COLOR); 
}
/******************************************/
/* ܣһСʮֱ               */
/* ڲx,y                  */
/******************************************/
void DrawCross(uint16_t x,uint16_t y)
{
    uint8_t b;    
    for(b=0; b<10; b++)
    {
        TFT_DrawPoint(240-(x),y-b);
        TFT_DrawPoint(240-(x),y+b);
        TFT_DrawPoint(240-(x+b),y);
        TFT_DrawPoint(240-(x-b),y);
    }
       
}	

/******************************************/
/* ܣTFTĳһɫ            */
/* ڲcolor  ɫֵ              */
/******************************************/
uint16_t TFT_ReadPoint(uint16_t x,uint16_t y)
{
	uint16_t  color;

	TFT_WR_REG_DATA(0x0020,x);//Xλ
  TFT_WR_REG_DATA(0x0021,y);//Yλ
	TFT_WR_REG(0x0022);       //ʼдGRAM
	
	GPIOB->MODER&=0xffff0000;		   
  GPIOC->MODER&=0xffff0000;        //TFTΪ
	
	color = TFT_RD_DATA();	  //GRAMֵע⣺GRAMֵȡΣ
	color = TFT_RD_DATA();	  //GRAMֵILI932xֲᣩ
	
	GPIOB->MODER|=0x00005555; 
	GPIOC->MODER|=0x00005555; 		  //ָΪ

	return color;
} 

/**********************************************/
/* ܣֱ                           */
/**********************************************/
void TFT_DrawLine(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2)
{
	uint16_t t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 

	delta_x=x2-x1; // 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; //õ 
	else if(delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )// 
	{  
		TFT_DrawPoint(uRow,uCol);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}
/**********************************************/
/* ܣ                           */
/**********************************************/
void TFT_DrawRectage(uint16_t xstart,uint16_t ystart,uint16_t xend,uint16_t yend,uint16_t color)
{
	POINT_COLOR=color;
	TFT_DrawLine(xstart, ystart, xend, ystart);
	TFT_DrawLine(xstart, yend, xend, yend);
	TFT_DrawLine(xstart, ystart, xstart, yend);
	TFT_DrawLine(xend, ystart, xend, yend);
}
/**********************************************/
/* ܣ                         */
/**********************************************/
void TFT_Fill(uint16_t xstart ,uint16_t ystart ,uint16_t xend ,uint16_t yend ,uint16_t color)
{                    
    uint32_t max;
	TFT_XYRAM(xstart ,ystart ,xend ,yend); // GRAM
	TFT_WR_REG_DATA(0x0020,xstart);//Xλ
    TFT_WR_REG_DATA(0x0021,ystart);//Yλ
    TFT_WR_REG(0x0022);				//ָRAMĴ׼дݵRAM
	max=(uint32_t)((xend-xstart+1)*(yend-ystart+1));    
	while(max--)
	{
		TFT_WR_DATA(color);
	}
	TFT_XYRAM(0x0000 ,0x0000 ,0x00EF ,0X013F); // ָGRAMʾ
}
/*******************************************/
/* ܣԲ                          */
/* ڲx0,y0  Բ               */
/*           r      뾶(λ)       */
/*******************************************/
void TFT_DrawCircle(uint8_t x0, uint16_t y0, uint8_t r)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             //ж¸λõı־
	while(a<=b)
	{
		TFT_DrawPoint(x0-b,y0-a);             //3           
		TFT_DrawPoint(x0+b,y0-a);             //0           
		TFT_DrawPoint(x0-a,y0+b);             //1       
		TFT_DrawPoint(x0-b,y0-a);             //7           
		TFT_DrawPoint(x0-a,y0-b);             //2             
		TFT_DrawPoint(x0+b,y0+a);             //4               
		TFT_DrawPoint(x0+a,y0-b);             //5
		TFT_DrawPoint(x0+a,y0+b);             //6 
		TFT_DrawPoint(x0-b,y0+a);             
		a++;
		//ʹBresenham㷨Բ     
		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		TFT_DrawPoint(x0+a,y0+b);
	}
} 
/**********************************************/
/* ܣmnη                       */
/**********************************************/
uint32_t mypow(uint8_t m,uint8_t n)
{
	uint32_t result=1;	 
	while(n--)result*=m;    
	return result;
}			 
/**********************************************/
/* ܣʾ                         */
/* ڲx,y :	 	              */
/*           len :ֵλ				  */
/*           num:ֵ(0~4294967295);	   	  */
/**********************************************/
void TFT_ShowNum(uint8_t x,uint16_t y,uint32_t num,uint8_t len)
{         	
	uint8_t t,temp;
	uint8_t enshow=0;		 // ˱ȥλ0	
				   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				TFT_ShowChar(x+8*t,y,' ');
				continue;
			}else enshow=1; 
		 	 
		}
	 	TFT_ShowChar(x+8*t,y,temp+'0'); 
	}
} 
/**********************************************/
/* ܣʾ8*16Ӣַ             */
/* ڲx,y :	 	              */
/*           num:ĸ         	   	  */
/* ע    ⣺x,yȡֵҪ240320Χ      */
/**********************************************/
void TFT_ShowChar(uint16_t x,uint16_t y,uint16_t num)
{
    uint8_t temp;
    uint8_t pos,t;
	      
   	TFT_WR_REG_DATA(0x0020,x);//Xλ
    TFT_WR_REG_DATA(0x0021,y);//Yλ
 	/*Դ*/
	TFT_XYRAM(x,y,x+7,y+15); // GRAM
    TFT_WR_REG(0x0022);	  	 //ָRAMĴ׼дݵRAM
 	
	num=num-' ';//õƫƺֵ
	for(pos=0;pos<16;pos++)
	{
	    temp=ascii_16[num][pos];
	    for(t=0;t<8;t++)
	    {                 
	        if(temp&0x80)TFT_WR_DATA(POINT_COLOR);
	        else TFT_WR_DATA(BACK_COLOR);    
	        temp<<=1; 
	    }
	}
	/* ָԴʾ240*320 */
	TFT_XYRAM(0x0000 ,0x0000 ,0x00EF ,0X013F); // ָGRAMʾ
	return;
}

uint8_t buf[32]; //ڴ16*16

// /**********************************************/
// /* ܣW25X16ȡ             */
// /* ڲcode:GBKһֽ             */
// /*           dz_data:ŵ         */
// /**********************************************/
// void Get_GBK_DZK(uint8_t *code, uint8_t *dz_data)
// {
// 	uint8_t GBKH,GBKL;   // GBKλλ					  
// 	uint32_t offset; 	   // ƫ

// 	GBKH=*code;
// 	GBKL=*(code+1);	   // GBKL=*(code+1);
// 	if(GBKH>0XFE||GBKH<0X81)return;
// 	GBKH-=0x81;
// 	GBKL-=0x40;
// 	offset=((uint32_t)192*GBKH+GBKL)*32;//õֿеֽƫ 
// 	W25X16_Read(dz_data,offset+0x100,32); 		  
// 	return;
// }
// /**********************************************/
// /* ܣʾ16*16                */
// /* ڲx,y :	 	              */
// /*           *hz               	   	  */
// /**********************************************/
// void TFT_Show_hz(uint16_t x,uint16_t y,uint8_t *hz)
// {
// 	uint8_t i,j,temp;
// 	uint8_t dz_data[32];

// 	Get_GBK_DZK(hz, dz_data);

// 	TFT_WR_REG_DATA(0x0020,x);//Xλ
//     TFT_WR_REG_DATA(0x0021,y);//Yλ
//  	/*Դ*/
// 	TFT_XYRAM(x,y,x+15,y+15); // GRAM
//     TFT_WR_REG(0x0022);	  	 //ָRAMĴ׼дݵRAM

//  	for(i=0;i<32;i++)
// 	{
// 		temp=dz_data[i];
// 	 	for(j=0;j<8;j++)
// 		{
// 		 	if(temp&0x80)TFT_WR_DATA(POINT_COLOR);
// 	        else TFT_WR_DATA(BACK_COLOR);    
// 	        temp<<=1; 
// 		}
// 	}

// 	/* ָԴʾ240*320 */
// 	TFT_XYRAM(0x0000 ,0x0000 ,0x00EF ,0X013F); // ָGRAMʾ
// 	
// 	return;
// }

/*********************************************/
/* ܣʾַĺӢģ        */
/* ڲx,y:                        */
/*           *p:ַ                       */
/*********************************************/
void TFT_ShowString(uint16_t x,uint16_t y,uint8_t *p)
{         
    while(*p!='\0')	// ûн
    {       
        if(*p>0x80)//
		{
			if((*p=='\n')||(x>224))  // κͻ
			{
				y=y+19;   //16 м3
				x=2;      //2Ǳ߾
			}
// 			TFT_Show_hz(x, y, p);
			x+=16;
			p+=2;
		}
		else	   //Ӣ
		{
			if((*p=='\n')||(x>224))   // κͻ
			{
				y=y+19;   //16 м3
				x=2;      //2Ǳ߾
			}
			TFT_ShowChar(x,y,*p);
			x+=8;
			p++;
		}
    }  
}

  


